Attribute VB_Name = "Module1"
Option Explicit

Public Const Zip_Version As Integer = &H14
Public Const Zip_Encrypt As Integer = 1
Public Const Deflate_SuperFast As Integer = 6
Public Const Deflate_Fast As Integer = 2
Public Const Deflate_Normal As Integer = 0
Public Const Deflate_Maximum As Integer = 4
Public Const Zip_UseDataDescriptor As Integer = 8
Public Const Method_Deflate As Integer = 8
Public Const LocalFileSignature As Long = &H4034B50
Public Const CentralFileSignature As Long = &H2014B50
Public Const EndCentralSignature As Long = &H6054B50

Type LocalFileHeader
    Signature As Long
    ReqVersion As Integer
    GeneralFlags As Integer
    CompressMethod As Integer
    LastModTime As Integer
    LastModDate As Integer
    crc32 As Long
    CompressedSize As Long
    FullSize As Long
    FileNameLength As Integer
    ExtraFieldLength As Integer
'   filename (variable size)
'   extra field (variable size)
End Type

Type DataDescriptor
    crc32 As Long
    CompressedSize As Long
    FullSize As Long
End Type

Type CentralFileHeader
    Signature As Long
    VersionMadeBy As Integer
    ReqVersion As Integer
    GeneralFlags As Integer
    CompressMethod As Integer
    LastModTime As Integer
    LastModDate As Integer
    crc32 As Long
    CompressedSize As Long
    FullSize As Long
    FileNameLength As Integer
    ExtraFieldLength As Integer
    FileCommentLength As Integer
    DiskNumberStart As Integer
    IntFileAttr As Integer
    ExtFileAttr As Long
    LocalHeaderOffset As Long
'   filename (variable size)
'   extra field (variable size)
'   file comment (variable size)
End Type

Type EndCentralDir
    Signature As Long
    ThisDiskNumber As Integer
    CentralDirDiskNumber As Integer
    DiskTotalEntries As Integer
    TotalEntries As Integer
    CentralDirSize As Long
    CentralDirOffset As Long
    ZipCommentLength As Integer
'   zipfile comment (variable size)
End Type

Public Const PAGE_READWRITE = &H4
Public Const PAGE_EXECUTE_READWRITE = &H40
Public Const MEM_COMMIT = &H1000
Public Const MEM_RELEASE = &H8000

' Memory allocation is required for VB4 because it lacks support for getting the address of a variable into another variable
Declare Function VirtualAlloc Lib "Kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Declare Function VirtualFree Lib "Kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Boolean
Declare Sub CopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Declare Function CallWindowProc Lib "User32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByRef hWnd As Any, ByRef Msg As Any, ByRef wParam As Any, ByRef lParam As Any) As Long
Declare Function CallWindowProcI Lib "User32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByRef hWnd As Any, ByRef Msg As Any, ByRef wParam As Any, ByRef lParam As Any) As Integer
Declare Function CallWindowProcB Lib "User32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByRef hWnd As Any, ByRef Msg As Any, ByRef wParam As Any, ByRef lParam As Any) As Byte
 
Public MultiplyProc As Long, AddProc As Long, RightShiftProc As Long, XModProc As Long, AddressOfProc As Long

Declare Function compress Lib "zlib.dll" (dest As Any, destLen As Any, src As Any, ByVal srcLen As Long) As Long
Declare Function uncompress Lib "zlib.dll" (dest As Any, destLen As Any, src As Any, ByVal srcLen As Long) As Long

Public Const ZLIB_VERSION = "1.1.4"
Public Const MAX_WBITS = 15 '/* 32K LZ77 window */
Public Const Z_SYNC_FLUSH = 2

Type z_stream
    next_in As Long  '/* next input byte */
    avail_in As Long   '/* number of bytes available at next_in */
    total_in As Long   '/* total nb of input bytes read so far */

    next_out As Long '/* next output byte should be put there */
    avail_out As Long  '/* remaining free space at next_out */
    total_out As Long  '/* total nb of bytes output so far */

    Msg As Long      '/* last error message, NULL if no error */
    internal_state As Long '/* not visible by applications */

    zalloc As Long     '/* used to allocate the internal state */
    zfree As Long      '/* used to free the internal state */
    opaque As Long     '/* private data object passed to zalloc and zfree */

    data_type As Long  '/* best guess about the data type: ascii or binary */
    adler As Long      '/* adler32 value of the uncompressed data */
    reserved As Long   '/* reserved for future use */
End Type

Declare Function inflateInit2_ Lib "zlib.dll" (ByRef strm As z_stream, ByVal windowBits As Long, ByVal version As String, ByVal stream_size As Long) As Long
Declare Function inflate Lib "zlib.dll" (ByRef strm As z_stream, ByVal flush As Long) As Long
Declare Function inflateEnd Lib "zlib.dll" (ByRef strm As z_stream) As Long

Declare Function crc32 Lib "zlib.dll" (ByVal crc As Long, ByRef buf As Any, ByVal blen As Long) As Long

Dim ZipKeys(2) As Long

Function AllocAsmCode() As Boolean
Dim buffer(78) As Byte
MultiplyProc = VirtualAlloc(0, 79, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
If MultiplyProc = 0 Then
    AllocAsmCode = False
    Exit Function
End If
AllocAsmCode = True
buffer(0) = &H55                                                      'push ebp
buffer(1) = &H8B: buffer(2) = &HEC                                    'mov         ebp,esp
buffer(3) = &H8B: buffer(4) = &H45: buffer(5) = &H8                   'mov         eax,dword ptr [ebp+8]
buffer(6) = &HF: buffer(7) = &HAF: buffer(8) = &H45: buffer(9) = &HC  'imul        eax,dword ptr [ebp+0Ch]
buffer(10) = &H8B: buffer(11) = &HE5                                  'mov         esp,ebp
buffer(12) = &H5D                                                     'pop         ebp
buffer(13) = &HC2: buffer(14) = &H10: buffer(15) = &H0                'ret         10h

RightShiftProc = MultiplyProc + 16
buffer(16) = &H55                                       'push ebp
buffer(17) = &H8B: buffer(18) = &HEC                    'mov         ebp,esp
buffer(19) = &H8B: buffer(20) = &H45: buffer(21) = &H8  'mov         eax,dword ptr [ebp+8]
buffer(22) = &H8B: buffer(23) = &H4D: buffer(24) = &HC  'mov         ecx,dword ptr [ebp+0Ch]
buffer(25) = &HD3: buffer(26) = &HE8                    'shr         eax,cl
buffer(27) = &H8B: buffer(28) = &HE5                    'mov         esp,ebp
buffer(29) = &H5D                                       'pop         ebp
buffer(30) = &HC2: buffer(31) = &H10: buffer(32) = &H0  'ret         10h

AddProc = MultiplyProc + 33
buffer(33) = &H55                                       'push ebp
buffer(34) = &H8B: buffer(35) = &HEC                    'mov         ebp,esp
buffer(36) = &H8B: buffer(37) = &H45: buffer(38) = &H8  'mov         eax,dword ptr [ebp+8]
buffer(39) = &H3: buffer(40) = &H45: buffer(41) = &HC   'add         eax,dword ptr [ebp+0Ch]
buffer(42) = &H8B: buffer(43) = &HE5                    'mov         esp,ebp
buffer(44) = &H5D                                       'pop         ebp
buffer(45) = &HC2: buffer(46) = &H10: buffer(47) = &H0  'ret         10h

XModProc = MultiplyProc + 48
buffer(48) = &H55                                       'push ebp
buffer(49) = &H8B: buffer(50) = &HEC                    'mov         ebp,esp
buffer(51) = &H8B: buffer(52) = &H45: buffer(53) = &H8  'mov         eax,dword ptr [ebp+8]
buffer(54) = &H33: buffer(55) = &HD2                    'xor         edx,edx
buffer(56) = &HF7: buffer(57) = &H75: buffer(58) = &HC  'div         eax,dword ptr [ebp+0Ch]
buffer(59) = &H8B: buffer(60) = &HC2                    'mov         eax,edx
buffer(61) = &H8B: buffer(62) = &HE5                    'mov         esp,ebp
buffer(63) = &H5D                                       'pop         ebp
buffer(64) = &HC2: buffer(65) = &H10: buffer(66) = &H0  'ret         10h

AddressOfProc = MultiplyProc + 67
buffer(67) = &H55                                       'push ebp
buffer(68) = &H8B: buffer(69) = &HEC                    'mov         ebp,esp
buffer(70) = &H8B: buffer(71) = &H45: buffer(72) = &H8  'mov         eax,dword ptr [ebp+8]
buffer(73) = &H8B: buffer(74) = &HE5                    'mov         esp,ebp
buffer(75) = &H5D                                       'pop         ebp
buffer(76) = &HC2: buffer(77) = &H10: buffer(78) = &H0  'ret         10h

CopyMemory ByVal MultiplyProc, buffer(0), 79
End Function
Sub FreeAsmCode()
If MultiplyProc <> 0 Then _
    VirtualFree MultiplyProc, 0, MEM_RELEASE
End Sub
Function Multiply(ByVal Factor1 As Long, ByVal Factor2 As Long) As Long
'Multiply = CurToLong(LongToCur(Factor1) * LongToCur(Factor2))
Multiply = CallWindowProc(MultiplyProc, ByVal Factor1, ByVal Factor2, ByVal 0&, ByVal 0&)
End Function
Function XMod(Dividend As Long, Divisor As Long) As Long
'XMod = (Dividend And &H7FFFFFFF) Mod (Divisor And &H7FFFFFFF)
XMod = CallWindowProc(XModProc, ByVal Dividend, ByVal Divisor, ByVal 0&, ByVal 0&)
End Function
Function ToInt(theint As Long) As Integer
ToInt = CallWindowProcI(AddressOfProc, ByVal theint, ByVal 0&, ByVal 0&, ByVal 0&)
End Function
Function ToByte(thebyte As Long) As Integer
ToByte = CallWindowProcB(AddressOfProc, ByVal thebyte, ByVal 0&, ByVal 0&, ByVal 0&)
End Function
Function AddressOfLong(ByRef varpt As Long) As Long
AddressOfLong = CallWindowProc(AddressOfProc, varpt, ByVal 0&, ByVal 0&, ByVal 0&)
End Function
Function AddressOfInteger(ByRef varpt As Integer) As Long
AddressOfInteger = CallWindowProc(AddressOfProc, varpt, ByVal 0&, ByVal 0&, ByVal 0&)
End Function
Function AddressOfByte(ByRef varpt As Byte) As Long
AddressOfByte = CallWindowProc(AddressOfProc, varpt, ByVal 0&, ByVal 0&, ByVal 0&)
End Function
Function AddressOfString(ByRef varpt As String) As Long
AddressOfString = CallWindowProc(AddressOfProc, ByVal varpt, ByVal 0&, ByVal 0&, ByVal 0&)
End Function
Function RightShift(ByVal theNumber As Long, ByVal ShiftBits As Long) As Long
'RightShift = CurToLong(LongToCur(theNumber) / 2 ^ LongToCur(ShiftBits))
RightShift = CallWindowProc(RightShiftProc, ByVal theNumber, ByVal ShiftBits, ByVal 0&, ByVal 0&)
End Function
Function Add(ByVal Number1 As Long, ByVal Number2 As Long) As Long
'Add = CurToLong(LongToCur(Number1) + LongToCur(Number2))
Add = CallWindowProc(AddProc, ByVal Number1, ByVal Number2, ByVal 0&, ByVal 0&)
End Function
Sub ZipDecrypt(ByRef buffer() As Byte, ByRef length As Long, password As String)
    Dim i As Long, C As Byte, temp As Byte

    ZipKeys(0) = 305419896
    ZipKeys(1) = 591751049
    ZipKeys(2) = 878082192

    For i = 1 To Len(password)
        update_keys Asc(Mid(password, i, 1))
    Next i

    For i = 0 To 11
        C = buffer(i) Xor decrypt_byte()
        update_keys C
        buffer(i) = C
    Next i

    For i = 12 To length - 1
        C = buffer(i)
        temp = C Xor decrypt_byte()
        update_keys temp
        buffer(i - 12) = temp
    Next i

    length = length - 12
    ReDim Preserve buffer(length - 1)
End Sub
Function decrypt_byte() As Byte
    Dim temp As Integer
    temp = ToInt(ZipKeys(2) Or 2)
    decrypt_byte = ToByte(RightShift(Multiply(temp, (temp Xor 1)), 8))
End Function
Sub update_keys(Char As Byte)
    ZipKeys(0) = crc32(ZipKeys(0), Char, 1)
    ZipKeys(1) = ZipKeys(1) + (ZipKeys(0) And &HFF&)
    ZipKeys(1) = Add(Multiply(ZipKeys(1), 134775813), 1)
    ZipKeys(2) = crc32(ZipKeys(2), RightShift(ZipKeys(1), 24), 1)
End Sub
